// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders } from '../runtime';
import type {
    AufgabeEntityDTO,
    AufgabeEntityListResponseDTO,
} from '../models';

export interface CreateAufgabeRequest {
    aufgabeEntityDTO: AufgabeEntityDTO;
}

export interface DeleteElementRequest {
    id: string;
}

export interface GetAufgabenListRequest {
    shortList: boolean;
}

export interface ModifyAufgabeRequest {
    aufgabeEntityDTO: AufgabeEntityDTO;
}

export interface SetElementAsResolvedRequest {
    id: string;
    setErledigt: boolean;
}

/**
 * no description
 */
export class AufgabeControllerApi extends BaseAPI {

    /**
     * Legt eine neue Aufgabe an
     * neue Aufgabe erstellt
     */
    createAufgabe({ aufgabeEntityDTO }: CreateAufgabeRequest): Observable<void>
    createAufgabe({ aufgabeEntityDTO }: CreateAufgabeRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    createAufgabe({ aufgabeEntityDTO }: CreateAufgabeRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(aufgabeEntityDTO, 'aufgabeEntityDTO', 'createAufgabe');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/aufgaben',
            method: 'POST',
            headers,
            body: aufgabeEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht alle erledigte Aufgaben im Dashboard
     * Löscht alle erledigte Aufgaben
     */
    deleteAllResolvedElements(): Observable<void>
    deleteAllResolvedElements(opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteAllResolvedElements(opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/aufgaben/delete-all-resolved',
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht eine Aufgaben im Dashboard
     * Löscht eine Aufgaben
     */
    deleteElement({ id }: DeleteElementRequest): Observable<void>
    deleteElement({ id }: DeleteElementRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteElement({ id }: DeleteElementRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteElement');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/aufgaben/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt alle Aufgaben im Dashboard an
     * Lädt alle Aufgaben
     */
    getAufgabenList({ shortList }: GetAufgabenListRequest): Observable<AufgabeEntityListResponseDTO>
    getAufgabenList({ shortList }: GetAufgabenListRequest, opts?: OperationOpts): Observable<AjaxResponse<AufgabeEntityListResponseDTO>>
    getAufgabenList({ shortList }: GetAufgabenListRequest, opts?: OperationOpts): Observable<AufgabeEntityListResponseDTO | AjaxResponse<AufgabeEntityListResponseDTO>> {
        throwIfNullOrUndefined(shortList, 'shortList', 'getAufgabenList');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AufgabeEntityListResponseDTO>({
            url: '/aufgaben/overview/{shortList}'.replace('{shortList}', encodeURI(shortList)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Bearbeitet eine Aufgabe
     * Aufgabe bearbeitet
     */
    modifyAufgabe({ aufgabeEntityDTO }: ModifyAufgabeRequest): Observable<void>
    modifyAufgabe({ aufgabeEntityDTO }: ModifyAufgabeRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    modifyAufgabe({ aufgabeEntityDTO }: ModifyAufgabeRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(aufgabeEntityDTO, 'aufgabeEntityDTO', 'modifyAufgabe');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/aufgaben/modify',
            method: 'PUT',
            headers,
            body: aufgabeEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Markiert einen Eintrag als gelesen
     * Markiert als gelesen
     */
    setElementAsResolved({ id, setErledigt }: SetElementAsResolvedRequest): Observable<void>
    setElementAsResolved({ id, setErledigt }: SetElementAsResolvedRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    setElementAsResolved({ id, setErledigt }: SetElementAsResolvedRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'setElementAsResolved');
        throwIfNullOrUndefined(setErledigt, 'setErledigt', 'setElementAsResolved');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/aufgaben/{id}/{setErledigt}'.replace('{id}', encodeURI(id)).replace('{setErledigt}', encodeURI(setErledigt)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

}
